## Date and Time Functions

Date and Time Functions — calendrical calculations and miscellaneous time stuff

## Functions

void | g_get_current_time ()
void | g_usleep ()
void | g_time_val_add ()
gboolean | g_time_val_from_iso8601 ()
gchar * | g_time_val_to_iso8601 ()
gint64 | g_get_monotonic_time ()
gint64 | g_get_real_time ()
GDate * | g_date_new ()
GDate * | g_date_new_dmy ()
GDate * | g_date_new_julian ()
void | g_date_clear ()
void | g_date_free ()
GDate * | g_date_copy ()
void | g_date_set_day ()
void | g_date_set_month ()
void | g_date_set_year ()
void | g_date_set_dmy ()
void | g_date_set_julian ()
void | g_date_set_time ()
void | g_date_set_time_t ()
void | g_date_set_time_val ()
void | g_date_set_parse ()
void | g_date_add_days ()
void | g_date_subtract_days ()
void | g_date_add_months ()
void | g_date_subtract_months ()
void | g_date_add_years ()
void | g_date_subtract_years ()
gint | g_date_days_between ()
gint | g_date_compare ()
void | g_date_clamp ()
void | g_date_order ()
GDateDay | g_date_get_day ()
GDateMonth | g_date_get_month ()
GDateYear | g_date_get_year ()
guint32 | g_date_get_julian ()
GDateWeekday | g_date_get_weekday ()
guint | g_date_get_day_of_year ()
guint8 | g_date_get_days_in_month ()
gboolean | g_date_is_first_of_month ()
gboolean | g_date_is_last_of_month ()
gboolean | g_date_is_leap_year ()
guint | g_date_get_monday_week_of_year ()
guint8 | g_date_get_monday_weeks_in_year ()
guint | g_date_get_sunday_week_of_year ()
guint8 | g_date_get_sunday_weeks_in_year ()
guint | g_date_get_iso8601_week_of_year ()
gsize | g_date_strftime ()
void | g_date_to_struct_tm ()
gboolean | g_date_valid ()
gboolean | g_date_valid_day ()
gboolean | g_date_valid_month ()
gboolean | g_date_valid_year ()
gboolean | g_date_valid_dmy ()
gboolean | g_date_valid_julian ()
gboolean | g_date_valid_weekday ()

## Types and Values

#define | G_USEC_PER_SEC
struct | GTimeVal
struct | GDate
typedef | GTime
enum | GDateDMY
typedef | GDateDay
enum | GDateMonth
typedef | GDateYear
enum | GDateWeekday
#define | G_DATE_BAD_DAY
#define | G_DATE_BAD_JULIAN
#define | G_DATE_BAD_YEAR

## Includes

    #include <glib.h>
    #include <glib/gprintf.h>

## Description

The GDate data structure represents a day between January 1, Year 1, and sometime a few thousand years in the future (right now it will go to the year 65535 or so, but `g_date_set_parse()` only parses up to the year 8000 or so - just count on "a few thousand"). GDate is meant to represent everyday dates, not astronomical dates or historical dates or ISO timestamps or the like. It extrapolates the current Gregorian calendar forward and backward in time; there is no attempt to change the calendar to match time periods or locations. GDate does not store time information; it represents a day.

The GDate implementation has several nice features; it is only a 64-bit struct, so storing large numbers of dates is very efficient. It can keep both a Julian and day-month-year representation of the date, since some calculations are much easier with one representation or the other. A Julian representation is simply a count of days since some fixed day in the past; for GDate the fixed day is January 1, 1 AD. ("Julian" dates in the GDate API aren't really Julian dates in the technical sense; technically, Julian dates count from the start of the Julian period, Jan 1, 4713 BC).

GDate is simple to use. First you need a "blank" date; you can get a dynamically allocated date from `g_date_new()`, or you can declare an automatic variable or array and initialize it to a sane state by calling `g_date_clear()`. A cleared date is sane; it's safe to call `g_date_set_dmy()` and the other mutator functions to initialize the value of a cleared date. However, a cleared date is initially invalid, meaning that it doesn't represent a day that exists. It is undefined to call any of the date calculation routines on an invalid date. If you obtain a date from a user or other unpredictable source, you should check its validity with the `g_date_valid()` predicate. `g_date_valid()` is also used to check for errors with `g_date_set_parse()` and other functions that can fail. Dates can be invalidated by calling `g_date_clear()` again.

It is very important to use the API to access the GDate struct. Often only the day-month-year or only the Julian representation is valid. Sometimes neither is valid. Use the API.

GLib also features GDateTime which represents a precise time.

## Functions

### g_get_current_time ()

    void
    g_get_current_time (GTimeVal *result);

Equivalent to the UNIX `gettimeofday()` function, but portable.

You may find `g_get_real_time()` to be more convenient.

#### Parameters

result | GTimeVal structure in which to store current time. |

### g_usleep ()

    void
    g_usleep (gulong microseconds);

Pauses the current thread for the given number of microseconds.

There are 1 million microseconds per second (represented by the G_USEC_PER_SEC macro). `g_usleep()` may have limited precision, depending on hardware and operating system; don't rely on the exact length of the sleep.

#### Parameters

microseconds | number of microseconds to pause |

### g_time_val_add ()

    void
    g_time_val_add (GTimeVal *time_,
                    glong microseconds);

Adds the given number of microseconds to `time_` . `microseconds` can also be negative to decrease the value of `time_` .

#### Parameters

time_ | a GTimeVal |
microseconds | number of microseconds to add to `time` |

### g_time_val_from_iso8601 ()

    gboolean
    g_time_val_from_iso8601 (const gchar *iso_date,
                             GTimeVal *time_);

Converts a string containing an ISO 8601 encoded date and time to a GTimeVal and puts it into `time_` .

`iso_date` must include year, month, day, hours, minutes, and seconds. It can optionally include fractions of a second and a time zone indicator. (In the absence of any time zone indication, the timestamp is assumed to be in local time.)

#### Parameters

iso_date | an ISO 8601 encoded date string |
time_ | a GTimeVal. | [out]

#### Returns

`TRUE` if the conversion was successful.

Since: 2.12

### g_time_val_to_iso8601 ()

    gchar *
    g_time_val_to_iso8601 (GTimeVal *time_);

Converts `time_` into an RFC 3339 encoded string, relative to the Coordinated Universal Time (UTC). This is one of the many formats allowed by ISO 8601.

ISO 8601 allows a large number of date/time formats, with or without punctuation and optional elements. The format returned by this function is a complete date and time, with optional punctuation included, the UTC time zone represented as "Z", and the `tv_usec` part included if and only if it is nonzero, i.e. either "YYYY-MM-DDTHH:MM:SSZ" or "YYYY-MM-DDTHH:MM:SS.fffffZ".

This corresponds to the Internet date/time format defined by RFC 3339, and to either of the two most-precise formats defined by the W3C Note Date and Time Formats. Both of these documents are profiles of ISO 8601.

Use `g_date_time_format()` or `g_strdup_printf()` if a different variation of ISO 8601 format is required.

If `time_` represents a date which is too large to fit into a `struct tm`, `NULL` will be returned. This is platform dependent, but it is safe to assume years up to 3000 are supported. The return value of `g_time_val_to_iso8601()` has been nullable since GLib 2.54; before then, GLib would crash under the same conditions.

#### Parameters

time_ | a GTimeVal |

#### Returns

a newly allocated string containing an ISO 8601 date, or `NULL` if `time_` was too large.

[nullable]

Since: 2.12

### g_get_monotonic_time ()

    gint64
    g_get_monotonic_time (void);

Queries the system monotonic time.

The monotonic clock will always increase and doesn't suffer discontinuities when the user (or NTP) changes the system time. It may or may not continue to tick during times where the machine is suspended.

We try to use the clock that corresponds as closely as possible to the passage of time as measured by system calls such as `poll()` but it may not always be possible to do this.

#### Returns

the monotonic time, in microseconds

Since: 2.28

### g_get_real_time ()

    gint64
    g_get_real_time (void);

Queries the system wall-clock time.

This call is functionally equivalent to `g_get_current_time()` except that the return value is often more convenient than dealing with a GTimeVal.

You should only use this call if you are actually interested in the real wall-clock time. `g_get_monotonic_time()` is probably more useful for measuring intervals.

#### Returns

the number of microseconds since January 1, 1970 UTC.

Since: 2.28

### g_date_new ()

    GDate *
    g_date_new (void);

Allocates a GDate and initializes it to a sane state. The new date will be cleared (as if you'd called `g_date_clear()`) but invalid (it won't represent an existing day). Free the return value with `g_date_free()`.

#### Returns

a newly-allocated GDate

### g_date_new_dmy ()

    GDate *
    g_date_new_dmy (GDateDay day,
                    GDateMonth month,
                    GDateYear year);

Like `g_date_new()`, but also sets the value of the date. Assuming the day-month-year triplet you pass in represents an existing day, the returned date will be valid.

#### Parameters

day | day of the month |
month | month of the year |
year | year |

#### Returns

a newly-allocated GDate initialized with `day` , `month` , and `year`

### g_date_new_julian ()

    GDate *
    g_date_new_julian (guint32 julian_day);

Like `g_date_new()`, but also sets the value of the date. Assuming the Julian day number you pass in is valid (greater than 0, less than an unreasonably large number), the returned date will be valid.

#### Parameters

julian_day | days since January 1, Year 1 |

#### Returns

a newly-allocated GDate initialized with `julian_day`

### g_date_clear ()

    void
    g_date_clear (GDate *date,
                  guint n_dates);

Initializes one or more GDate structs to a sane but invalid state. The cleared dates will not represent an existing date, but will not contain garbage. Useful to init a date declared on the stack. Validity can be tested with `g_date_valid()`.

#### Parameters

date | pointer to one or more dates to clear |
n_dates | number of dates to clear |

### g_date_free ()

    void
    g_date_free (GDate *date);

Frees a GDate returned from `g_date_new()`.

#### Parameters

date | a GDate to free |

### g_date_copy ()

    GDate *
    g_date_copy (const GDate *date);

Copies a GDate to a newly-allocated GDate. If the input was invalid (as determined by `g_date_valid()`), the invalid state will be copied as is into the new object.

#### Parameters

date | a GDate to copy |

#### Returns

a newly-allocated GDate initialized from `date` .

[transfer full]

Since: 2.56

### g_date_set_day ()

    void
    g_date_set_day (GDate *date,
                    GDateDay day);

Sets the day of the month for a GDate. If the resulting day-month-year triplet is invalid, the date will be invalid.

#### Parameters

date | a GDate |
day | day to set |

### g_date_set_month ()

    void
    g_date_set_month (GDate *date,
                      GDateMonth month);

Sets the month of the year for a GDate. If the resulting day-month-year triplet is invalid, the date will be invalid.

#### Parameters

date | a GDate |
month | month to set |

### g_date_set_year ()

    void
    g_date_set_year (GDate *date,
                     GDateYear year);

Sets the year for a GDate. If the resulting day-month-year triplet is invalid, the date will be invalid.

#### Parameters

date | a GDate |
year | year to set |

### g_date_set_dmy ()

    void
    g_date_set_dmy (GDate *date,
                    GDateDay day,
                    GDateMonth month,
                    GDateYear y);

Sets the value of a GDate from a day, month, and year. The day-month-year triplet must be valid; if you aren't sure it is, call `g_date_valid_dmy()` to check before you set it.

#### Parameters

date | a GDate |
day | day |
month | month |
y | year |

### g_date_set_julian ()

    void
    g_date_set_julian (GDate *date,
                       guint32 julian_date);

Sets the value of a GDate from a Julian day number.

#### Parameters

date | a GDate |
julian_date | Julian day number (days since January 1, Year 1) |

### g_date_set_time ()

    void
    g_date_set_time (GDate *date,
                     GTime time_);

`g_date_set_time` has been deprecated since version 2.10 and should not be used in newly-written code.

Use `g_date_set_time_t()` instead.

Sets the value of a date from a GTime value. The time to date conversion is done using the user's current timezone.

#### Parameters

date | a GDate. |
time_ | GTime value to set. |

### g_date_set_time_t ()

    void
    g_date_set_time_t (GDate *date,
                       time_t timet);

Sets the value of a date to the date corresponding to a time specified as a time_t. The time to date conversion is done using the user's current timezone.

To set the value of a date to the current day, you could write:

    1

    g_date_set_time_t (date, time (NULL));

#### Parameters

date | a GDate |
timet | time_t value to set |

Since: 2.10

### g_date_set_time_val ()

    void
    g_date_set_time_val (GDate *date,
                         GTimeVal *timeval);

Sets the value of a date from a GTimeVal value. Note that the `tv_usec` member is ignored, because GDate can't make use of the additional precision.

The time to date conversion is done using the user's current timezone.

#### Parameters

date | a GDate |
timeval | GTimeVal value to set |

Since: 2.10

### g_date_set_parse ()

    void
    g_date_set_parse (GDate *date,
                      const gchar *str);

Parses a user-inputted string `str` , and try to figure out what date it represents, taking the current locale into account. If the string is successfully parsed, the date will be valid after the call. Otherwise, it will be invalid. You should check using `g_date_valid()` to see whether the parsing succeeded.

This function is not appropriate for file formats and the like; it isn't very precise, and its exact behavior varies with the locale. It's intended to be a heuristic routine that guesses what the user means by a given string (and it does work pretty well in that capacity).

#### Parameters

date | a GDate to fill in |
str | string to parse |

### g_date_add_days ()

    void
    g_date_add_days (GDate *date,
                     guint n_days);

Increments a date some number of days. To move forward by weeks, add weeks*7 days. The date must be valid.

#### Parameters

date | a GDate to increment |
n_days | number of days to move the date forward |

### g_date_subtract_days ()

    void
    g_date_subtract_days (GDate *date,
                          guint n_days);

Moves a date some number of days into the past. To move by weeks, just move by weeks*7 days. The date must be valid.

#### Parameters

date | a GDate to decrement |
n_days | number of days to move |

### g_date_add_months ()

    void
    g_date_add_months (GDate *date,
                       guint n_months);

Increments a date by some number of months. If the day of the month is greater than 28, this routine may change the day of the month (because the destination month may not have the current day in it). The date must be valid.

#### Parameters

date | a GDate to increment |
n_months | number of months to move forward |

### g_date_subtract_months ()

    void
    g_date_subtract_months (GDate *date,
                            guint n_months);

Moves a date some number of months into the past. If the current day of the month doesn't exist in the destination month, the day of the month may change. The date must be valid.

#### Parameters

date | a GDate to decrement |
n_months | number of months to move |

### g_date_add_years ()

    void
    g_date_add_years (GDate *date,
                      guint n_years);

Increments a date by some number of years. If the date is February 29, and the destination year is not a leap year, the date will be changed to February 28. The date must be valid.

#### Parameters

date | a GDate to increment |
n_years | number of years to move forward |

### g_date_subtract_years ()

    void
    g_date_subtract_years (GDate *date,
                           guint n_years);

Moves a date some number of years into the past. If the current day doesn't exist in the destination year (i.e. it's February 29 and you move to a non-leap-year) then the day is changed to February 29. The date must be valid.

#### Parameters

date | a GDate to decrement |
n_years | number of years to move |

### g_date_days_between ()

    gint
    g_date_days_between (const GDate *date1,
                         const GDate *date2);

Computes the number of days between two dates. If `date2` is prior to `date1` , the returned value is negative. Both dates must be valid.

#### Parameters

date1 | the first date |
date2 | the second date |

#### Returns

the number of days between `date1` and `date2`

### g_date_compare ()

    gint
    g_date_compare (const GDate *lhs,
                    const GDate *rhs);

qsort()-style comparison function for dates. Both dates must be valid.

#### Parameters

lhs | first date to compare |
rhs | second date to compare |

#### Returns

0 for equal, less than zero if `lhs` is less than `rhs` , greater than zero if `lhs` is greater than `rhs`

### g_date_clamp ()

    void
    g_date_clamp (GDate *date,
                  const GDate *min_date,
                  const GDate *max_date);

If `date` is prior to `min_date` , sets `date` equal to `min_date` . If `date` falls after `max_date` , sets `date` equal to `max_date` . Otherwise, `date` is unchanged. Either of `min_date` and `max_date` may be `NULL`. All non-`NULL` dates must be valid.

#### Parameters

date | a GDate to clamp |
min_date | minimum accepted value for `date` |
max_date | maximum accepted value for `date` |

### g_date_order ()

    void
    g_date_order (GDate *date1,
                  GDate *date2);

Checks if `date1` is less than or equal to `date2` , and swap the values if this is not the case.

#### Parameters

date1 | the first date |
date2 | the second date |

### g_date_get_day ()

    GDateDay
    g_date_get_day (const GDate *date);

Returns the day of the month. The date must be valid.

#### Parameters

date | a GDate to extract the day of the month from |

#### Returns

day of the month

### g_date_get_month ()

    GDateMonth
    g_date_get_month (const GDate *date);

Returns the month of the year. The date must be valid.

#### Parameters

date | a GDate to get the month from |

#### Returns

month of the year as a GDateMonth

### g_date_get_year ()

    GDateYear
    g_date_get_year (const GDate *date);

Returns the year of a GDate. The date must be valid.

#### Parameters

date | a GDate |

#### Returns

year in which the date falls

### g_date_get_julian ()

    guint32
    g_date_get_julian (const GDate *date);

Returns the Julian day or "serial number" of the GDate. The Julian day is simply the number of days since January 1, Year 1; i.e., January 1, Year 1 is Julian day 1; January 2, Year 1 is Julian day 2, etc. The date must be valid.

#### Parameters

date | a GDate to extract the Julian day from |

#### Returns

Julian day

### g_date_get_weekday ()

    GDateWeekday
    g_date_get_weekday (const GDate *date);

Returns the day of the week for a GDate. The date must be valid.

#### Parameters

date | a GDate |

#### Returns

day of the week as a GDateWeekday.

### g_date_get_day_of_year ()

    guint
    g_date_get_day_of_year (const GDate *date);

Returns the day of the year, where Jan 1 is the first day of the year. The date must be valid.

#### Parameters

date | a GDate to extract day of year from |

#### Returns

day of the year

### g_date_get_days_in_month ()

    guint8
    g_date_get_days_in_month (GDateMonth month,
                              GDateYear year);

Returns the number of days in a month, taking leap years into account.

#### Parameters

month | month |
year | year |

#### Returns

number of days in `month` during the `year`

### g_date_is_first_of_month ()

    gboolean
    g_date_is_first_of_month (const GDate *date);

Returns `TRUE` if the date is on the first of a month. The date must be valid.

#### Parameters

date | a GDate to check |

#### Returns

`TRUE` if the date is the first of the month

### g_date_is_last_of_month ()

    gboolean
    g_date_is_last_of_month (const GDate *date);

Returns `TRUE` if the date is the last day of the month. The date must be valid.

#### Parameters

date | a GDate to check |

#### Returns

`TRUE` if the date is the last day of the month

### g_date_is_leap_year ()

    gboolean
    g_date_is_leap_year (GDateYear year);

Returns `TRUE` if the year is a leap year.

For the purposes of this function, leap year is every year divisible by 4 unless that year is divisible by 100. If it is divisible by 100 it would be a leap year only if that year is also divisible by 400.

#### Parameters

year | year to check |

#### Returns

`TRUE` if the year is a leap year

### g_date_get_monday_week_of_year ()

    guint
    g_date_get_monday_week_of_year (const GDate *date);

Returns the week of the year, where weeks are understood to start on Monday. If the date is before the first Monday of the year, return 0. The date must be valid.

#### Parameters

date | a GDate |

#### Returns

week of the year

### g_date_get_monday_weeks_in_year ()

    guint8
    g_date_get_monday_weeks_in_year (GDateYear year);

Returns the number of weeks in the year, where weeks are taken to start on Monday. Will be 52 or 53. The date must be valid. (Years always have 52 7-day periods, plus 1 or 2 extra days depending on whether it's a leap year. This function is basically telling you how many Mondays are in the year, i.e. there are 53 Mondays if one of the extra days happens to be a Monday.)

#### Parameters

year | a year |

#### Returns

number of Mondays in the year

### g_date_get_sunday_week_of_year ()

    guint
    g_date_get_sunday_week_of_year (const GDate *date);

Returns the week of the year during which this date falls, if weeks are understood to begin on Sunday. The date must be valid. Can return 0 if the day is before the first Sunday of the year.

#### Parameters

date | a GDate |

#### Returns

week number

### g_date_get_sunday_weeks_in_year ()

    guint8
    g_date_get_sunday_weeks_in_year (GDateYear year);

Returns the number of weeks in the year, where weeks are taken to start on Sunday. Will be 52 or 53. The date must be valid. (Years always have 52 7-day periods, plus 1 or 2 extra days depending on whether it's a leap year. This function is basically telling you how many Sundays are in the year, i.e. there are 53 Sundays if one of the extra days happens to be a Sunday.)

#### Parameters

year | year to count weeks in |

#### Returns

the number of weeks in `year`

### g_date_get_iso8601_week_of_year ()

    guint
    g_date_get_iso8601_week_of_year (const GDate *date);

Returns the week of the year, where weeks are interpreted according to ISO 8601.

#### Parameters

date | a valid GDate |

#### Returns

ISO 8601 week number of the year.

Since: 2.6

### g_date_strftime ()

    gsize
    g_date_strftime (gchar *s,
                     gsize slen,
                     const gchar *format,
                     const GDate *date);

Generates a printed representation of the date, in a locale-specific way. Works just like the platform's C library `strftime()` function, but only accepts date-related formats; time-related formats give undefined results. Date must be valid. Unlike `strftime()` (which uses the locale encoding), works on a UTF-8 format string and stores a UTF-8 result.

This function does not provide any conversion specifiers in addition to those implemented by the platform's C library. For example, don't expect that using `g_date_strftime()` would make the %F provided by the C99 `strftime()` work on Windows where the C library only complies to C89.

#### Parameters

s | destination buffer |
slen | buffer size |
format | format string |
date | valid GDate |

#### Returns

number of characters written to the buffer, or 0 the buffer was too small

### g_date_to_struct_tm ()

    void
    g_date_to_struct_tm (const GDate *date,
                         struct tm *tm);

Fills in the date-related bits of a struct tm using the `date` value. Initializes the non-date parts with something sane but meaningless.

#### Parameters

date | a GDate to set the struct tm from |
tm | struct tm to fill. | [not nullable]

### g_date_valid ()

    gboolean
    g_date_valid (const GDate *date);

Returns `TRUE` if the GDate represents an existing day. The date must not contain garbage; it should have been initialized with `g_date_clear()` if it wasn't allocated by one of the `g_date_new()` variants.

#### Parameters

date | a GDate to check |

#### Returns

Whether the date is valid

### g_date_valid_day ()

    gboolean
    g_date_valid_day (GDateDay day);

Returns `TRUE` if the day of the month is valid (a day is valid if it's between 1 and 31 inclusive).

#### Parameters

day | day to check |

#### Returns

`TRUE` if the day is valid

### g_date_valid_month ()

    gboolean
    g_date_valid_month (GDateMonth month);

Returns `TRUE` if the month value is valid. The 12 GDateMonth enumeration values are the only valid months.

#### Parameters

month | month |

#### Returns

`TRUE` if the month is valid

### g_date_valid_year ()

    gboolean
    g_date_valid_year (GDateYear year);

Returns `TRUE` if the year is valid. Any year greater than 0 is valid, though there is a 16-bit limit to what GDate will understand.

#### Parameters

year | year |

#### Returns

`TRUE` if the year is valid

### g_date_valid_dmy ()

    gboolean
    g_date_valid_dmy (GDateDay day,
                      GDateMonth month,
                      GDateYear year);

Returns `TRUE` if the day-month-year triplet forms a valid, existing day in the range of days GDate understands (Year 1 or later, no more than a few thousand years in the future).

#### Parameters

day | day |
month | month |
year | year |

#### Returns

`TRUE` if the date is a valid one

### g_date_valid_julian ()

    gboolean
    g_date_valid_julian (guint32 julian_date);

Returns `TRUE` if the Julian day is valid. Anything greater than zero is basically a valid Julian, though there is a 32-bit limit.

#### Parameters

julian_date | Julian day to check |

#### Returns

`TRUE` if the Julian day is valid

### g_date_valid_weekday ()

    gboolean
    g_date_valid_weekday (GDateWeekday weekday);

Returns `TRUE` if the weekday is valid. The seven GDateWeekday enumeration values are the only valid weekdays.

#### Parameters

weekday | weekday |

#### Returns

`TRUE` if the weekday is valid

## Types and Values

### G_USEC_PER_SEC

    #define G_USEC_PER_SEC 1000000

Number of microseconds in one second (1 million). This macro is provided for code readability.

### struct GTimeVal

    struct GTimeVal {
      glong tv_sec;
      glong tv_usec;
    };

Represents a precise time, with seconds and microseconds. Similar to the struct timeval returned by the `gettimeofday()` UNIX system call.

GLib is attempting to unify around the use of 64bit integers to represent microsecond-precision time. As such, this type will be removed from a future version of GLib.

#### Members

glong `tv_sec`; | seconds |
glong `tv_usec`; | microseconds |

### struct GDate

    struct GDate {
      guint julian_days : 32; /* julian days representation - we use a
                               *  bitfield hoping that 64 bit platforms
                               *  will pack this whole struct in one big
                               *  int
                               */

      guint julian : 1;    /* julian is valid */
      guint dmy    : 1;    /* dmy is valid */

      /* DMY representation */
      guint day    : 6;
      guint month  : 4;
      guint year   : 16;
    };

Represents a day between January 1, Year 1 and a few thousand years in the future. None of its members should be accessed directly.

If the GDate is obtained from `g_date_new()`, it will be safe to mutate but invalid and thus not safe for calendrical computations.

If it's declared on the stack, it will contain garbage so must be initialized with `g_date_clear()`. `g_date_clear()` makes the date invalid but sane. An invalid date doesn't represent a day, it's "empty." A date becomes valid after you set it to a Julian day or you set a day, month, and year.

#### Members

guint `julian_days` : 32; | the Julian representation of the date |
guint `julian` : 1; | this bit is set if `julian_days` is valid |
guint `dmy` : 1; | this is set if `day` , `month` and `year` are valid |
guint `day` : 6; | the day of the day-month-year representation of the date, as a number between 1 and 31 |
guint `month` : 4; | the day of the day-month-year representation of the date, as a number between 1 and 12 |
guint `year` : 16; | the day of the day-month-year representation of the date |

### GTime

    typedef gint32  GTime;

Simply a replacement for time_t. It has been deprecated since it is not equivalent to time_t on 64-bit platforms with a 64-bit time_t. Unrelated to GTimer.

Note that GTime is defined to always be a 32-bit integer, unlike time_t which may be 64-bit on some systems. Therefore, GTime will overflow in the year 2038, and you cannot use the address of a GTime variable as argument to the UNIX `time()` function.

Instead, do the following:

    1
    2
    3
    4
    5

    time_t ttime;
    GTime gtime;

    time (&ttime);
    gtime = (GTime)ttime;

### enum GDateDMY

This enumeration isn't used in the API, but may be useful if you need to mark a number as a day, month, or year.

#### Members

G_DATE_DAY | a day |
G_DATE_MONTH | a month |
G_DATE_YEAR | a year |

### GDateDay

    typedef guint8  GDateDay;   /* day of the month */

Integer representing a day of the month; between 1 and 31. G_DATE_BAD_DAY represents an invalid day of the month.

### enum GDateMonth

Enumeration representing a month; values are G_DATE_JANUARY, G_DATE_FEBRUARY, etc. G_DATE_BAD_MONTH is the invalid value.

#### Members

G_DATE_BAD_MONTH | invalid value |
G_DATE_JANUARY | January |
G_DATE_FEBRUARY | February |
G_DATE_MARCH | March |
G_DATE_APRIL | April |
G_DATE_MAY | May |
G_DATE_JUNE | June |
G_DATE_JULY | July |
G_DATE_AUGUST | August |
G_DATE_SEPTEMBER | September |
G_DATE_OCTOBER | October |
G_DATE_NOVEMBER | November |
G_DATE_DECEMBER | December |

### GDateYear

    typedef guint16 GDateYear;

Integer representing a year; G_DATE_BAD_YEAR is the invalid value. The year must be 1 or higher; negative (BC) years are not allowed. The year is represented with four digits.

### enum GDateWeekday

Enumeration representing a day of the week; G_DATE_MONDAY, G_DATE_TUESDAY, etc. G_DATE_BAD_WEEKDAY is an invalid weekday.

#### Members

G_DATE_BAD_WEEKDAY | invalid value |
G_DATE_MONDAY | Monday |
G_DATE_TUESDAY | Tuesday |
G_DATE_WEDNESDAY | Wednesday |
G_DATE_THURSDAY | Thursday |
G_DATE_FRIDAY | Friday |
G_DATE_SATURDAY | Saturday |
G_DATE_SUNDAY | Sunday |

### G_DATE_BAD_DAY

    #define G_DATE_BAD_DAY    0U

Represents an invalid GDateDay.

### G_DATE_BAD_JULIAN

    #define G_DATE_BAD_JULIAN 0U

Represents an invalid Julian day number.

### G_DATE_BAD_YEAR

    #define G_DATE_BAD_YEAR   0U

Represents an invalid year.